<template>
  <!-- ONBOARDING COMPONENT -->
  <!-- id="onboarding" -->
  <div v-show="componentToShow == CatalejoApp.Onboarding">
    <OnboardingComponent></OnboardingComponent>
    <div class="center animate__animated animate__fadeInDownBig">
      <button
        class="animate__animated animate__pulse animate__infinite"
        v-on:click="componentToShow = CatalejoApp.Menu"
      >
        ¡Empieza!
      </button>
    </div>
  </div>
  <!-- MENU COMPONENT -->
  <div v-show="componentToShow == CatalejoApp.Menu">
    <MenuAppComponent @fromParentGoToProjects="goToProjects"></MenuAppComponent>
  </div>
  <!-- PROJECTS COMPONENT -->
  <div v-show="componentToShow == CatalejoApp.Projects">
    <ProjectsComponent
      @fromParentLoadProjectFromFile="loadProjectFromFile"
    ></ProjectsComponent>
  </div>
  <!-- EDITOR COMPONENT -->
  <!-- id="editorDesktop" -->
  <div v-show="componentToShow == CatalejoApp.Editor">
    <EditorDesktopComponent :fileHandle="fileHandle"></EditorDesktopComponent>
  </div>
</template>

<script lang="ts">
/**
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * @fileoverview Main Vue component that includes the Blockly component.
 * @author Johnny Cubides <jgcubidesc@gmail.com>
 */

// import { Component, Vue } from 'vue-property-decorator'
import { defineComponent, ref, onMounted } from "vue";
import EditorDesktopComponent from "./components/EditorDesktopComponent.vue";
import OnboardingComponent from "./components/OnboardingComponent.vue";
import MenuAppComponent from "./components/MenuAppComponent.vue";
import ProjectsComponent from "./components/ProjectsComponent.vue";
import { CatalejoApp } from "./host/defCatalejo";
import "animate.css"; // https://animate.style/

const App = defineComponent({
  name: "app",
  components: {
    OnboardingComponent,
    MenuAppComponent,
    ProjectsComponent,
    EditorDesktopComponent,
  },
  // tslint:disable-next-line
  setup (_, context) { // eslint-disable-line

    // Select component to show
    const componentToShow = ref(CatalejoApp.Onboarding);
    //componentToShow.value = CatalejoApp.Editor;
    const fileHandle = ref();
    const goToProjects = (): void => {
      componentToShow.value = CatalejoApp.Projects;
    };

    const loadProjectFromFile = (fileHandleEmited): void => {
      fileHandle.value = fileHandleEmited;
      componentToShow.value = CatalejoApp.Editor;
    };

    return {
      // --VARS --
      CatalejoApp,
      componentToShow,
      fileHandle,
      // -- METHODS --
      goToProjects,
      loadProjectFromFile,
      // -- MODALS VARS MSG --
      // -- MODALS TRIGGERS --
      // -- METHODS FOR EMITS --
    };
  },
});

export default App;
</script>

<style>
#app {
  font-family: "Avenir", Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  color: #2c3e50;
  display: flex;
  flex-direction: column;
  margin: 0;
}

.center {
  text-align: center;
}

html,
body {
  margin: 0;
  background-color: #2c3e50;
}
</style>
